import student.GUITestCase;

//-------------------------------------------------------------------------
/**
 * An example test case that shows how to test drag/drop and mouse clicks.
 *
 *  @author Stephen Edwards
 *  @version 2010.02.21
 */
public class RubberLinesPanelTest
    extends GUITestCase
{
    //~ Test methods ..........................................................

    // ----------------------------------------------------------
    /**
     * A simple example of a test method for exercising PushCounterPanel.
     */
    public void testRubberLinesPanel()
    {
        RubberLinesPanel panel = new RubberLinesPanel();
        showInFrame(panel);
        int width = panel.getWidth();
        int height = panel.getHeight();

        // Mouse events are easy, too
        mouseDragFrom(panel, width * 3 / 4, height * 3 / 4);
        mouseDropOn(panel, width * 1 / 4, height * 1 / 4);

        // While it is technically possible to take a
        // "snapshot" of a component on-screen, that is
        // error-prone and time-consuming.  Instead, just
        // add getters for the start and end points of
        // the current line to your panel class--make
        // your testing job easy!

        // When comparing the coordinates below, don't forget that
        // points have floating-point coordinates, not integer coordinates
        assertEquals(width  * 3/4, (int)panel.getStartPoint().getX());
        assertEquals(height * 3/4, (int)panel.getStartPoint().getY());
        assertEquals(width  * 1/4, (int)panel.getEndPoint().getX());
        assertEquals(height * 1/4, (int)panel.getEndPoint().getY());
    }


    // ----------------------------------------------------------
    /**
     * The same test as above, but now with mousePress()/mouseMove()/
     * mouseRelease() instead drag/drop.
     */
    public void testRubberLinesPanel2()
    {
        RubberLinesPanel panel = new RubberLinesPanel();
        showInFrame(panel);
        int width = panel.getWidth();
        int height = panel.getHeight();

        // Mouse events are easy, too
        mousePress(panel, width * 3 / 4, height * 3 / 4);
        mouseMove(panel, width * 1 / 4, height * 1 / 4);
        mouseRelease();

        // While it is technically possible to take a
        // "snapshot" of a component on-screen, that is
        // error-prone and time-consuming.  Instead, just
        // add getters for the start and end points of
        // the current line to your panel class--make
        // your testing job easy!

        // When comparing the coordinates below, don't forget that
        // points have floating-point coordinates, not integer coordinates
        assertEquals(width  * 3/4, (int)panel.getStartPoint().getX());
        assertEquals(height * 3/4, (int)panel.getStartPoint().getY());
        assertEquals(width  * 1/4, (int)panel.getEndPoint().getX());
        assertEquals(height * 1/4, (int)panel.getEndPoint().getY());
    }


    // place other test methods here ...
}
